<?php
// Макрос с автором
/* @ author Denys Petrenko < Des . Petrenko @ gmail . com >
 */

//  Дано два числа 42 и 55 определите при помощи тернарной операции какое число больше.
$firstNumber = 42;
$secondNumber = 55;
echo $secondNumber > $firstNumber ? 'это число больше' : 'это число меньше';

//Используй вместо статических чисел функцию rand() для задачи (1);
// Пример я ограничил набор случайных чисел от 5 до 15 echo rand(5, 15);
//ex2
echo '<br>';
echo 'задача номер 2';
echo '<br>';
echo '<br>';
$numberOne = rand(5, 15);
$numberTwo = rand(5, 15);
echo $numberOne > $numberTwo ? 'число больше' : 'число меньше';
echo '<br>';

//ex3
//Сокращение Имени и Отчества. Возьмите за основу свою ФИО.
// Ваша программа должна сократить Имя и Отчество.
// У вас будет 3 переменные. (Ф.И.О.)вот пример:(Иванов Иван Иванович) => (Иванов И. И.)
$name = 'Denys';
$surname = 'Petrenko';
$patronic = 'Sergeevich';
echo 'Меня зовут ' . $surname . ' ' . $name[0] . '. ' . $patronic[0] . '. ';
echo '<br>';
//ex4
//Вам нужно разработать программу, которая считала бы количество вхождений
// какой-нибудь выбранной вами цифры в выбранном вами числе.
//Например: цифра 7 в числе 123456789 встречается 1 раза
//(ограничите себя функцией rand(1, 99999).– это ваше случайное число) используй функцию substr_count()
$number = 3;
$arrOfNumber = rand(1, 9999);
echo 'количество ' . $number . '= ' . substr_count($arrOfNumber, $number);
echo '<br>';
echo '<strong>' . 'Переменные' . ' </strong>';
echo '<br>';
//Создайте переменную $a и присвойте ей значение 3. Выведите значение этой переменной на экран.
$a = 3;
echo $a;
echo '<br>';
//Создайте переменные $a=10 и $b=2. Выведите на экран их сумму, разность, произведение и частное (результат деления).
$a = 10;
$b = 2;
echo '<br>';
echo $a + $b . ' сложение';
echo '<br>';
echo $a - $b . ' вычитание';
echo '<br>';
echo $a * $b . ' умножение';
echo '<br>';
echo $a / $b . ' деление';
echo '<br>';
//Создайте переменные $c=15 и $d=2. Просуммируйте их, а результат присвойте переменной $result.
// Выведите на экран значение переменной $result.
$c = 15;
$d = 2;
$result = $c + $d;
echo $result;
echo '<br>';
//Создайте переменные $a=10, $b=2 и $c=5. Выведите на экран их сумму.
$a = 10;
$b = 2;
$c = 5;
echo $a . ' + ' . $b . ' + ' . $c . ' = ' . ($a + $b + $c);
echo '<br>';
//Создайте переменные $a=17 и $b=10. Отнимите от $a переменную $b и результат присвойте переменной $c. Затем
//            создайте переменную $d, присвойте ей значение 6. Сложите переменные $c и $d, а результат запишите в
//            переменную $result. Выведите на экран значение переменной $result.
$a = 17;
$b = 10;
$c = $a - $b;
$d = 6;
echo $result = $c + $d;
echo '<br>';
echo '<strong>' . 'Строки' . ' </strong>';
echo '<br>';
echo '<br>';
//Создайте переменную $text и присвойте ей значение 'Привет, Мир!'.
// Выведите значение этой переменной на экран.
echo $text = 'Привет, Мир!';
echo '<br>';
//Создайте переменные $text1='Привет, ' и $text2='Мир!'.
// С помощью этих переменных и операции сложения строк выведите на экран фразу 'Привет, Мир!'.
$text1 = 'Привет,';
$text2 = 'Мир!';
echo $text1 . ' ' . $text2;
echo '<br>';
//Напишите скрипт, который считает количество секунд в часе, сутках, неделе, месяце из 30 дней.
$secondInMin = 60;
$minOnHour = 60;
$hourOnDay = 24;
$daysOnWeek = 7;
$dayOnMonth = 30;
echo $secOnHour = $secondInMin * $minOnHour . ' количество секунд в часе';
echo '<br>';
echo $secOnDay = $secOnHour * $hourOnDay . ' количество секунд в сутках';
echo '<br>';
echo $secOnWeek = $secOnDay * $daysOnWeek . ' количество секунд в неделе';
echo '<br>';
echo $secOnMonth = $secOnDay * $dayOnMonth . ' количество секунд в месяце';
echo '<br>';
//Переделайте приведенный код так, чтобы в нем использовались операции +=, -=, *=, /=, ++, --.
// Количество строк кода при этом не должно измениться! Код для переделки:
//
//$var = 1;
//$var = $var + 12;
//$var = $var - 14;
//$var = $var * 5;
//$var = $var / 7;
//$var = $var % 1;
//echo $var;
echo '<br>';
$var = 1;
$var += 12;
$var -= 14;
$var *= 5;
$var /= 7;
$var %= 1;
echo $var;
echo '<br>';
//Создайте три переменные - час, минута, секунда.
//С их п омощью выведите текущее время в формате 'час:минута:секунда'.
$sec = date('s');
$min = date('i');
$hour = date('h');
echo '$hour:$min:$sec';
echo '<br>';
// Такой вариант короче
echo date('H:i:s');
echo '<br>';
//Переделайте этот код так, чтобы в нем использовалась операция .=. Количество строк кода при этом не должно измениться!
//
//$text = 'Я';
//$text = $text .' хочу';
//$text = $text .' знать';
//$text = $text .' PHP!';
//echo $text;

$text = 'Я';
$text .= ' хочу';
$text .= ' знать';
$text .= ' PHP';
echo $text;
echo '<br>';
//Задана переменная $foo = 'bar';
// Создать переменную bar, в которой будет храниться число 10.
// Вывести число 10, используя только переменную $foo
$foo = 'bar';
$bar = 10;
echo $$foo;
echo '<br>';
//Какой будет результат если:
//$a = 2;
//$b = 4
// перепроверить на всякий случай
echo 6;//echo $a++ + $b; переменная инкементируется и складывается с переменной б
echo 7;//echo $a + ++$b; переменная б инкементируется и складывается с переменной а
echo 7;//echo ++$a + $b++; переменная а инкрементируется и складывается с переменной б, инкремент б уже не учитывается
echo '<br>';
//Функции для проверки типов данных.
// Определите что у вас в переменной.
// Решение должно быть универсальным.
// Используйте тернарную операцию. Используй все эти функции:
//1. isset()
//2. gettype()
//3. is_null()
//4. empty()
//5. is_integer($a)
//6. is_double ($a)
//7. is_string ($a)
//8. is_numeric($a)
//9. is_bool($a)
//10. is_scalar($a)
//11. is_null($a)
//12. is_array($a)
//13. is_object($a)
$a = 'asd';
echo is_string($a) ? 'переменная строка' : 'переменная не строка';
echo '<br>';
echo gettype($a) ? 'переменная bool' : 'переменная не бул';
echo '<br>';
echo is_null($a) ? 'переменная не null' : 'переменная null';
echo '<br>';
echo empty($a) ? 'переменная не пустая' : 'переменная пустая';
echo '<br>';
echo is_integer($a) ? 'переменная число' : 'переменная строка';
echo '<br>';
echo is_double($a) ? 'переменная double' : 'переменная не double';
echo '<br>';
echo is_string($a) ? 'переменная строка' : 'не строка';
echo '<br>';
echo is_numeric($a) ? 'переменная числа или строка, содержашая число' : 'переменная не число и не строка с числом';
echo '<br>';
echo is_bool($a) ? 'переменная булево зачение' : 'не булево';
echo '<br>';
echo is_scalar($a) ? 'переменная скалярное значение (число, строка, бул)' : 'не скалярное значение';
echo '<br>';
echo is_null($a) ? 'переменная не null' : 'переменная null';
echo '<br>';
echo is_array($a) ? 'переменная содержит массив' : 'не содержит массив';
echo '<br>';
echo is_object($a) ? 'переменная обьект' : 'не обьект';
echo '<strong>' . '***' . ' </strong>';
//Даны два числа. Найти их сумму и произведение.
$firstNumber = rand(1, 99);
$secondNumber = rand(1, 99);
echo '<br>';
echo 'сумма рандомных чисел = ' . ($firstNumber + $secondNumber);
echo '<br>';
echo 'произведение рандомных чисел = ' . ($firstNumber * $secondNumber);
echo '<br>';
//Даны два числа. Найдите сумму их квадратов.
$firstNumber = rand(1, 99);
$secondNumber = rand(1, 99);
echo 'сумма квадратов рандомных чисел =' . (pow($firstNumber, 2) + pow($secondNumber, 2));  // pow() - функция возведения в квадрат
echo '<br>';
//Даны три числа. Найдите их среднее арифметическое
$thirdNumber = 9;
$numbers = [$firstNumber => 5, $secondNumber => 7, $thirdNumber => 9];
// можно просто через сложение и деление. Либо через цикл for, но этот вариант мне показался самым интересным. Возжно, затратный
echo array_sum($numbers) / count($numbers) . ' среднее арифметическое';
echo '<br>';
//Даны три числа x,y и z. Найдите (x+1)−2(z−2x+y)
$x = 5;
$y = 7;
$z = 9;
echo ($x + 1) - 2 * ($z - 2 * $x + $y) . ' результат решения формулы';
echo '<br>';
//Дано натуральное число.
// Найдите остатки от деления этих чисел на 3 и на 5.
// Дано число. Увеличьте его на 30%, на 120%.
$age = 32;
echo 'остаток от деления %3 = ' . $age % 3;
echo 'остаток от деления %5 = ' . $age % 5;
echo $age * 0.3;
echo $age * 1.2;
echo '<br>';
// Дано два числа. Найдите сумму 40% от первого числа и 84% от второго числа.
//Дано трехзначное числа. Найдите сумму его цифр.
$firstNumber = 9;
$secondNumber = 12;
echo ($firstNumber * 0.4) + ($secondNumber * 0.84);
echo '<br>';
$bigNumber = 333;
//решение через встроенную функцию
echo array_sum(str_split($bigNumber)) . ' = сумма чисел числа 333';
//7. Дано трехзначное числа.
// Поменяйте среднюю цифру на ноль.
// Найдите число, полученное выписыванием в обратном порядке цифр данного трехзначного натурального числа.
$bigNumber = 333;
$bigNumber = (string)$bigNumber;
$bigNumber[1] = 0;
echo $bigNumber[2] . $bigNumber[1] . $bigNumber[0];
echo '<br>';
//задача деление по модулю.
// определить какое число четное или не четное.
// Реализовать через тернарную операцию.
$num1 = 10;
$num2 = 3;
echo $num1 % 2 == 0 ? 'чет' : 'нечет';
echo '<br>';
echo $num2 % 2 == 0 ? 'чет' : 'нечет';
